import 'codec.dart';
import 'utils.dart';

int genNowMsgID() {
  return DateTime.now().microsecondsSinceEpoch;
}

class Packet {
  final List<int> to;
  final int id;
  final List<int> from;
  final List<int> data;

  Packet(this.to, this.id, this.from, this.data);

  static Packet decode(List<int> b) {
    var parts = Codec.decode(b);
    return Packet(
        parts[0], Utils.parseBinaryToInt(parts[1]), parts[2], parts[3]);
  }

  @override
  String toString() {
    return {
      "to": to,
      "from": from,
      "id": id,
      "data": data,
    }.toString();
  }

  List<int> encode() {
    return Codec.encode([to, Utils.int64ToBinary(id), from, data]);
  }
}
